package com.primerEjemplo.Modelo.Servicio;

import com.primerEjemplo.Modelo.Interfaz.IServicioLibro;
import com.primerEjemplo.Modelo.Interfaz.CargaDatos;
import com.primerEjemplo.Modelo.Libro;

import java.io.FileNotFoundException;
import java.util.Collection;
import java.util.List;

public class ImplementaIntefazServicioGeneral implements IServicioLibro {

    private final List<Libro> libros;
    private Libro libro;

    public ImplementaIntefazServicioGeneral() throws FileNotFoundException {
        libros = CargaDatos.getDatos();
    }

    @Override
    public Libro buscarLibro(String isbn) {
        libro = iterarLibros(isbn);
        return libro;
    }

    @Override
    public boolean venderLibro(String isbn) {
        libro = iterarLibros(isbn);
        try{
            if (libro.getEstado().equalsIgnoreCase("publish")){
                return libros.remove(libro);
            }
        }catch (NullPointerException n){
            return false;
        }
        return true;
    }

    @Override
    public String mostrarLibroResumen(String isbn) {
        libro = iterarLibros(isbn);

        if (libro == null){
            System.out.println("Error");
        }
        System.out.println(libro.printarResumenLibro());
        return isbn;
    }

    @Override
    public Collection<Libro> mostrarLibrosResumen() {
        return libros;
    }

    @Override
    public Collection<Libro> mostrarLibros() {
        return  libros;
    }

    @Override
    public boolean anyadirLibro(Libro libro) {
        return libros.add(libro);
    }

    public Libro iterarLibros(String isbn){
        for (Libro value : libros) {
            if (value.getIsbn().equalsIgnoreCase(isbn)) {
                libro = value;
                return libro;
            }
        }
        return null;
    }


}
