package com.primerEjemplo;

import Lib.Control;
import Lib.Util;
import com.primerEjemplo.Modelo.Libro;
import com.primerEjemplo.Modelo.Servicio.Servicio;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Scanner;

public class Tienda {


    private final Servicio servicio;

    @Autowired
    public Tienda(Servicio servicio) {
        this.servicio = servicio;
        menuPrincipal();
    }

    public void menuPrincipal(){
        Scanner scanner = Util.myInput;
        String[] opciones ={"Salir", "Mostrar Todos los libros", "Mostrar categorias", "Mostrar por categoria", "Mostrar por ISBN", "Mostrar por titulo",  "Mostrar por periodo", "Comprar libro",};
        String titulo = "BIENVENIDO A NUESTRA TIENDA";
        int opcion = Control.menuGenerator(0,titulo,opciones);
        String respuesta;
        switch (opcion) {
            case 0  -> System.out.println("HASTA PRONTO !!");
            case 1 -> servicio.mostrarLibros().forEach(System.out::println);
            case 2 -> servicio.mostrarCategorias().forEach(System.out::println);
            case 3 -> {
                System.out.println("Introduce el catalgo del libro");
                respuesta = scanner.nextLine();
                servicio.mostrarPorCategoria(respuesta).forEach(System.out::println);
            }
            case 4 -> {
                System.out.println("Introduce el ISBN del libro");
                respuesta = scanner.nextLine();
                System.out.println(servicio.buscarLibro(respuesta));
            }
            case 5 -> {
                System.out.println("Introduce el titulo del libro");
                respuesta = scanner.nextLine();
                servicio.encontrarPorTitulo(respuesta).forEach(System.out::println);
            }
            case 6 -> {
                System.out.println("Introduce el desde que anyo quieres filtrar los libros ");
                respuesta = scanner.nextLine();
                System.out.println("Introduce el anyo fin que quieres filtrar los libros");
                String respuesta1 = scanner.nextLine();
                servicio.encontrarPorPeriodo(respuesta, respuesta1).forEach(System.out::println);
            }
            case 7 -> {
                System.out.println("Introduce el isbn del libro que deseas seleccionar");
                respuesta = scanner.nextLine();
                System.out.println(servicio.buscarLibro(respuesta));
                if (servicio.venderLibro(respuesta)){
                    System.out.println("LIBRO VENDIDO EXITOSAMENTE");
                }else{
                    System.out.println("LO SENTIMOS EL LIBRO NO ESTA DISPONIBLE");
                }

            }

        }

        Util.pause();
        Util.cleanScreen();

        if(Control.one("Quieres volver al menu principal s/n",'s')){
            menuPrincipal();
        }else{
            System.out.println("Hasta luego !!");
        }


    }





}
